searchData={"items":[{"type":"module","title":"SuperCache","doc":"SeperCache is a library support for caching data in memory.\nThe library is based on Ets table and use some function from :ets for making it easy & friendly to use.\nSuperCache support auto scale based on number of cpu cores and easy to use.\nType of data is supported is tuple, other type of data can put in a tuple an storage in SuperCache.\nCurrent version is not support for replicating data to multi nodes in Elixir cluster.","ref":"SuperCache.html"},{"type":"function","title":"SuperCache.delete!/1","doc":"Detele data in cache with key & partition store same as `put!` function","ref":"SuperCache.html#delete!/1"},{"type":"function","title":"SuperCache.delete_all/0","doc":"Detele all data in cache.","ref":"SuperCache.html#delete_all/0"},{"type":"function","title":"SuperCache.delete_by_key_partition!/2","doc":"Delete data in a partition by key & data which used to get partition.","ref":"SuperCache.html#delete_by_key_partition!/2"},{"type":"function","title":"SuperCache.delete_by_match!/1","doc":"Same as `delete_by_match` but with all partitions in cache.","ref":"SuperCache.html#delete_by_match!/1"},{"type":"function","title":"SuperCache.delete_by_match!/2","doc":"Delete data by pattern in a partition.","ref":"SuperCache.html#delete_by_match!/2"},{"type":"function","title":"SuperCache.delete_same_key_partition!/1","doc":"Delete data in a partition by key & data which used to get partition is key.","ref":"SuperCache.html#delete_same_key_partition!/1"},{"type":"function","title":"SuperCache.get/1","doc":"Same with get!/1 function but doesn's raise error if failed.","ref":"SuperCache.html#get/1"},{"type":"function","title":"SuperCache.get!/1","doc":"Get data (list of tuple) from cache.\nThis is simple way to get data but need key & partition data must same postion with config.","ref":"SuperCache.html#get!/1"},{"type":"function","title":"SuperCache.get_by_key_partition!/2","doc":"Get data from cache with key and paritition.\nFunction return list of tuple.","ref":"SuperCache.html#get_by_key_partition!/2"},{"type":"function","title":"SuperCache.get_by_match!/1","doc":"Scan all storage partitions with pattern.\n\nFunction works like :ets.","ref":"SuperCache.html#get_by_match!/1"},{"type":"function","title":"SuperCache.get_by_match!/2","doc":"Gets objects in storage by pattern matching. If partition data is atom :_, it will scan all\npartitions.\n\nFunction works like `:ets.match_pattern/2`","ref":"SuperCache.html#get_by_match!/2"},{"type":"function","title":"SuperCache.get_by_match_object!/1","doc":"Function works like `get_by_match_object!/2`, it will scan all partitions.","ref":"SuperCache.html#get_by_match_object!/1"},{"type":"function","title":"SuperCache.get_by_match_object!/2","doc":"The function works like `:ets.match_object/2`.\npartition_data is used to get partition. if partition_data = :_ the function will scan all partitions.","ref":"SuperCache.html#get_by_match_object!/2"},{"type":"function","title":"SuperCache.get_same_key_partition!/1","doc":"Get data from cache in case key_pos & partition in config is same.\nFunction return list of tuple.","ref":"SuperCache.html#get_same_key_partition!/1"},{"type":"function","title":"SuperCache.lazy_put/1","doc":"Data is push to buffer before it was written to cache.\nIf you don't need read data immediately this will help improve performance.","ref":"SuperCache.html#lazy_put/1"},{"type":"function","title":"SuperCache.put/1","doc":"Store tuple to cache. The function works like `put!(data)`\nResult return is true or {:error, reason}","ref":"SuperCache.html#put/1"},{"type":"function","title":"SuperCache.put!/1","doc":"Store tuple to cache.\n\nTuple size of parameter must be equal or larger than key_pos/partition_pos.\n\nThe function must call after `start!` SuperCache.\n\nIf success the function will return true, other cases it will raise a error.","ref":"SuperCache.html#put!/1"},{"type":"function","title":"SuperCache.scan!/2","doc":"Function works like `scan!/2` but with all paritions.","ref":"SuperCache.html#scan!/2"},{"type":"function","title":"SuperCache.scan!/3","doc":"Function is used to call anonymous function with data(tuple) in a partition.\nacc parameter is used to call function with special options or store data.","ref":"SuperCache.html#scan!/3"},{"type":"function","title":"SuperCache.start/0","doc":"Init & start library.\n\nFunction uses default config like `start!()`","ref":"SuperCache.html#start/0"},{"type":"function","title":"SuperCache.start/1","doc":"Start library with config. Parameters like `start!(opts)`","ref":"SuperCache.html#start/1"},{"type":"function","title":"SuperCache.start!/0","doc":"Start SuperCache service (use default config).\n\nIf function is failed, it will raise a error.\n\nDefault config:\n  - key_pos: 0\n  - partition_pos: 0\n  - table_type: :set\n  - num_partition: = number of online_schedulers of Erlang VM","ref":"SuperCache.html#start!/0"},{"type":"function","title":"SuperCache.start!/1","doc":"Start SuperCache service with config.\n\nConfig is in Keyword list\n\nIf key_pos or parition_pos is missed, start SuperCache will raise an error.","ref":"SuperCache.html#start!/1"},{"type":"function","title":"SuperCache.started?/0","doc":"Check library is started or not.","ref":"SuperCache.html#started?/0"},{"type":"function","title":"SuperCache.stats/0","doc":"Get stats in all tables","ref":"SuperCache.html#stats/0"},{"type":"function","title":"SuperCache.stop/0","doc":"Clear data & stop library. Call if application no more use SuperCache to free memory.","ref":"SuperCache.html#stop/0"},{"type":"module","title":"SuperCache.Internal.Queue","doc":"","ref":"SuperCache.Internal.Queue.html"},{"type":"function","title":"SuperCache.Internal.Queue.add/2","doc":"receives data then store in queue.","ref":"SuperCache.Internal.Queue.html#add/2"},{"type":"function","title":"SuperCache.Internal.Queue.get/1","doc":"gets data from queue","ref":"SuperCache.Internal.Queue.html#get/1"},{"type":"function","title":"SuperCache.Internal.Queue.start/1","doc":"","ref":"SuperCache.Internal.Queue.html#start/1"},{"type":"function","title":"SuperCache.Internal.Queue.stop/1","doc":"","ref":"SuperCache.Internal.Queue.html#stop/1"},{"type":"module","title":"SuperCache.Internal.Stream","doc":"","ref":"SuperCache.Internal.Stream.html"},{"type":"function","title":"SuperCache.Internal.Stream.create/1","doc":"","ref":"SuperCache.Internal.Stream.html#create/1"},{"type":"function","title":"SuperCache.Internal.Stream.make_stream_pipe/1","doc":"","ref":"SuperCache.Internal.Stream.html#make_stream_pipe/1"},{"type":"function","title":"SuperCache.Internal.Stream.push/1","doc":"","ref":"SuperCache.Internal.Stream.html#push/1"},{"type":"module","title":"SuperCache.KeyValue","doc":"Key-Value(KV) database in memory.\nCan use multiple KV cache by using different KV name.\nThis is global KV cache any process can access.\nThe KV is store in with cache.\nNeed to start SuperCache.start!/1 before using this module.","ref":"SuperCache.KeyValue.html"},{"type":"function","title":"SuperCache.KeyValue.add/3","doc":"Add key-value to cache. Key is used to get target partition to store data.\nUse can use multiple kv cache by using different kv_name.","ref":"SuperCache.KeyValue.html#add/3"},{"type":"function","title":"SuperCache.KeyValue.get/3","doc":"Get value by key.\nKey is belong wit kv_name.","ref":"SuperCache.KeyValue.html#get/3"},{"type":"function","title":"SuperCache.KeyValue.keys/1","doc":"Get all keys in kv_name cache.","ref":"SuperCache.KeyValue.html#keys/1"},{"type":"function","title":"SuperCache.KeyValue.remove/2","doc":"","ref":"SuperCache.KeyValue.html#remove/2"},{"type":"function","title":"SuperCache.KeyValue.values/1","doc":"Get all values in kv_name cache.","ref":"SuperCache.KeyValue.html#values/1"},{"type":"module","title":"SuperCache.Queue","doc":"A queue based on cache.\nData in queue stored in cache.\nCan handle multiple queue with different name.\nA queue is a FIFO data structure.\nThis is global data, any process can access to queue data.\nNeed to start SuperCache.start!/1 before using this module.","ref":"SuperCache.Queue.html"},{"type":"function","title":"SuperCache.Queue.add/2","doc":"Add value to queue with name is queue_name.\nQueue is a FIFO data structure. If queue_name is not existed, it will be created.","ref":"SuperCache.Queue.html#add/2"},{"type":"function","title":"SuperCache.Queue.out/2","doc":"Pop value from queue with name is queue_name.\nIf queue_name is not existed or no data, it will return default value.","ref":"SuperCache.Queue.html#out/2"},{"type":"module","title":"SuperCache.Stack","doc":"Stack module helps to easy to use stack data structure.\nThis is global stack, any process can access to stack data.\nCan handle multiple stack with different name.\nNeed to start SuperCache.start!/1 before using this module.","ref":"SuperCache.Stack.html"},{"type":"function","title":"SuperCache.Stack.pop/2","doc":"Pop value from stack with name is stack_name.\nIf stack_name is not existed or no data, it will return default value.","ref":"SuperCache.Stack.html#pop/2"},{"type":"function","title":"SuperCache.Stack.push/2","doc":"Add value to stack has name is stack_name.\nIf stack_name is not existed, it will be created.","ref":"SuperCache.Stack.html#push/2"},{"type":"extras","title":"Benchmark","doc":"# Benchmark","ref":"benchmark.html"},{"type":"extras","title":"Hardware - Benchmark","doc":"Run on Windows 11 Pro x64\n\nCPU AMD 3700x (8C/16T)\n\nRAM 64GB 2600","ref":"benchmark.html#hardware"},{"type":"extras","title":"Script test - Benchmark","doc":"Ets table config for both:\n\n```elixir\n  ...\n  {:write_concurrency, true},\n  {:read_concurrency, true},\n  {:decentralized_counters, true}\n  ...\n```\n\nScript is available at tools folder","ref":"benchmark.html#script-test"},{"type":"extras","title":"Result - Benchmark","doc":"","ref":"benchmark.html#result"},{"type":"extras","title":"16 worker processes - Benchmark","doc":"16 processes are send requests to target.\n\nSuperCache:\n\n```\nlazy write     32_000_000 records need 8.93s, 3_582_236.85 req/s\nwrite          32_000_000 records need 83.5s, 383_226.81 req/s\nread           32_000_000 records need 8.66s, 3_693_853.43 req/s\nmix read/write 32_000_000 records need 10.88s, 2_942_312.02 req/s\n```\n\nRead/write direct on one Ets table:\n\n```\nwrite          32_000_000 records need 8.71s, 3_673_013.63 req/s\nread           32_000_000 records need 6.05s, 5_291_856.64 req/s\nmix read/write 32_000_000 records need 9.76s, 3_277_055.37 req/s\n```","ref":"benchmark.html#16-worker-processes"},{"type":"extras","title":"40 worker processes - Benchmark","doc":"","ref":"benchmark.html#40-worker-processes"},{"type":"extras","title":"Guide","doc":"# Guide\n\nSuperCache is similar to Ets for easy to use.\nCurrent version, it's support limited function from Ets, ex: insert, lookup, delete, match_object, scan object.\n\nStart SuperCache with default config:\n\n```elixir\nSuperCache.start!()\n```\n\n*default config: [key_pos = partition_pos = 0, table_type = :set, num_partition = online schedulers of Erlang VM]*\n\nStart with config:\n\n```elixir\nopts = [key_pos: 0, partition_pos: 1, table_type: :bag, num_partition: 3]\nSuperCache.start!(opts)\n```\n\nNote:\n\n1. key_pos: Key's position of tuple use to lookup in Ets table.\n\n2. partition_pos: Position of element in tuple is used to calculate partition for store & lookup.\n\n3. table_type: Type of Ets table.\n\n4. num_partition: Number of partitions (= number of Ets table) on a node.\n\nIn almost case `key_pos` and `partition_pos` is same.\nIf you need to organize data for fast access you can choose right data to calculate partition.\nEach partition have one or more replicated partition for local access & backup.\n\nBasic usage:\n\n```elixir\nopts = [key_pos: 0, partition_pos: 1, table_type: :bag, num_partition: 3]\nSuperCache.start!(opts)\n\nSuperCache.put!({:hello, :world, \"hello world!\"})\n\nSuperCache.get_by_key_partition!(:hello, :world)\n\nSuperCache.delete_by_key_partition!(:hello, :world)\n\nSuperCache.put({:a, :b, 1, 3, \"c\"})\n\nSuperCache.get_by_match_object!({:_, :_, 1, :_, \"c\"})\n[{:a, :b, 1, 3, \"c\"}]\n\n```\n\nIn case, key_pos & partition_pos is same:\n\n```elixir\nSuperCache.put({:hello, :world, :example})\nSuperCache.get_same_key_partition!(:hello)\nSuperCache.delete\n```","ref":"guide.html"},{"type":"extras","title":"Readme","doc":"# SuperCache","ref":"readme.html"},{"type":"extras","title":"Introduce - Readme","doc":"This is a auto scale & distributed (in the future) cache library for Elixir. The library use Ets table for storage data.","ref":"readme.html#introduce"},{"type":"extras","title":"Design - Readme","doc":"```\nClient -> API -> Partition -> Storage\n```\n\nCurrent version, library has three main part:\n1. API interface & config holder.\n2. Partition holder.\n3. Storage partition.","ref":"readme.html#design"},{"type":"extras","title":"API interface: - Readme","doc":"Client interacts with library throw qua api interface. All config after start will be hold in this part.","ref":"readme.html#api-interface"},{"type":"extras","title":"Partition - Readme","doc":"Support api get right storage part for data. \n\nPartition based on Erlang phash2/2. Piece data after extract with config's info will get order of partition. Order is used get target partition.\n\nAll partitions will be calculated after client call start/n start!/n function.","ref":"readme.html#partition"},{"type":"extras","title":"Storage - Readme","doc":"Storage data of client. Number of storage partition is same with number of partition above.\n\nCore of storage is Ets table.","ref":"readme.html#storage"},{"type":"extras","title":"call flow of api - Readme","doc":"Sequencer flow of api (on a node):\n\n```mermaid\nsequenceDiagram\n  participant Client\n  participant Api\n  participant Partition\n  participant Storage\n\n  Client->>Api: Add new tuple to cache\n  Api->>Partition: Get partition\n  Partition->>Api: Your partition\n  Api->>Storage: Put new/update tuple\n  Storage->>Api: Result\n  Api->>Client: Result\n  \n  Client->>Api: Get data for key/pattern\n  Api->>Partition: Get partition\n  Partition->>Api: Your patition\n  Api->>Storage: Get data for key/pattern\n  Storage->>Api: Data for key\n  Api->>Client: Your data\n```\n\n(If diagram doesn't show, please install mermaid support extension for VS Code)\n\nSimple module flow api:\n\n```mermaid\ngraph LR\nClient(Client) --> Api(Api)\n    Api-->|get partition|Part(Partition holder)\n    Api-->|Partition1| E1(Partition Storage 1)\n    Api-->|Partition2| E2(Partition Storage 2)\n```","ref":"readme.html#call-flow-of-api"},{"type":"extras","title":"Installation - Readme","doc":"Requiremnt: Erlang/OTP version 25 or later.\n\nLibrary can be installed\nby adding `super_cache` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:super_cache, \"~> 0.5.2\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Guide - Readme","doc":"Start SuperCache with default config:\n\n```elixir\nSuperCache.start!()\n```\n*(key_pos = partition_pos = 0, table_type = :set, num_partition = on_line schedulers of Erlang VM)*\n\nStart with config:\n\n```elixir\nopts = [key_pos: 0, partition_pos: 1, table_type: :bag, num_partition: 3]\nSuperCache.start!(opts)\n```\n\nNote:\n\n1. key_pos: Key's position of tuple use to lookup in Ets table.\n\n2. partition_pos: Position of element in tuple is used to calculate partition for store & lookup.\n\n3. table_type: Type of Ets table.\n\n4. num_partition: Number of partitions (= number of Ets table).\n\nBasic usage:\n\n```elixir\nopts = [key_pos: 0, partition_pos: 1, table_type: :bag, num_partition: 3]\nSuperCache.start!(opts)\n\nSuperCache.put!({:hello, :world, \"hello world!\"})\n\nSuperCache.get_by_key_partition!(:hello, :world)\n\nSuperCache.delete_by_key_partition!(:hello, :world)\n```\n\nOther APIs please go to document on [hexdocs.pm](https://hexdocs.pm/super_cache/readme.html)","ref":"readme.html#guide"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}